VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5490
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5490
   ScaleWidth      =   9000
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   960
      TabIndex        =   7
      Top             =   5040
      Width           =   1215
   End
   Begin VB.CheckBox chkShowOriginalSize 
      Caption         =   "1:1"
      Height          =   375
      Left            =   0
      TabIndex        =   6
      Top             =   5040
      Width           =   855
   End
   Begin VB.FileListBox filFiles 
      Height          =   1650
      Left            =   0
      TabIndex        =   3
      Top             =   2640
      Width           =   2175
   End
   Begin VB.DirListBox dirDirectory 
      Height          =   2115
      Left            =   0
      TabIndex        =   2
      Top             =   480
      Width           =   2175
   End
   Begin VB.DriveListBox drvDrive 
      Height          =   315
      Left            =   0
      TabIndex        =   1
      Top             =   120
      Width           =   2175
   End
   Begin VB.PictureBox picHidden 
      AutoSize        =   -1  'True
      Height          =   855
      Left            =   2760
      ScaleHeight     =   53
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   69
      TabIndex        =   0
      Top             =   4320
      Visible         =   0   'False
      Width           =   1095
   End
   Begin VB.Label lblHeight 
      Caption         =   "Label1"
      Height          =   255
      Left            =   0
      TabIndex        =   5
      Top             =   4680
      Width           =   2175
   End
   Begin VB.Label lblWidth 
      Caption         =   "Label1"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   4320
      Width           =   2175
   End
   Begin VB.Image imgShow 
      Height          =   4800
      Left            =   2280
      Stretch         =   -1  'True
      Top             =   120
      Width           =   6400
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Beispiel zum Anzeigen der Vorschau-Bitmap eines SolidWorks-Dokument
' in Visual Basic. Dazu unter Projekt/Verweise den Verweis auf die
' sdm.dll einbinden (angezeigt als sdm 1.0 Type library)
' ACHTUNG: nicht offiziell untersttzt
'
' Sample project which shows the preview bitmap within a SolidWorks
' document in Visual Basic. You must implement the reference to
' sdm.dll (shown as sdm 1.0 Type library)
'
' Stefan Berlitz  07.10.2001
' http://solidworks.cad.de
' http://swtools.cad.de
'
' Dank an / thanks to:
' Armin B aus dem SolidWorksForum bei CAD.DE



Option Explicit
' TEMP-Pfad
' path to TEMP

Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" _
    (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Private strTemp As String


Private Sub chkShowOriginalSize_Click()
    ' wenn 1:1 angezeigt werden soll dass automatische Anpassen ausschalten
    ' if shown as 1:1 switch of the autostrech of imagecontrol
    If chkShowOriginalSize.Value = 0 Then
        Form_Resize
        imgShow.Stretch = True
    Else
        imgShow.Stretch = False
    End If
End Sub

Private Sub cmdExit_Click()
    End
End Sub

Private Sub dirDirectory_Change()
    ' Dateiliste des neuen Verzeichnisses darstellen
    ' change fileliste to new directory
    filFiles.Path = dirDirectory.Path
    
End Sub

Private Sub drvDrive_Change()
    ' Verzeichnis wechseln, wenn Laufwerk wechselt
    ' change the directory to new drive
    dirDirectory.Path = drvDrive.Drive
    
End Sub

Private Sub filFiles_Click()
    ' wenn SolidWorks Dokument angeklickt wurde das Vorschaubild extrahieren
    ' und in der Picturebox anzeigen. Benutzt immer denselben temporren Namen
    ' if SolidWorks document extract the preview bitmap and display it
    ' in the picturebox. Always uses the same temp file name
    
    Dim sldFilename As String
    Dim tmpFilename As String
    
    ' Verweis auf die sdm.dll Funktion zum extrahieren der Bitm0ap einbinden
    ' get handle for the extract bitmap function in sdm.dll
    Dim BmpSaver As New SDMLib.smBitMap
    
    sldFilename = dirDirectory.Path + "\" + filFiles.List(filFiles.ListIndex)
    tmpFilename = strTemp + "tempsdlbmp.bmp"
    
    If BmpSaver.extractBitMap2File(sldFilename, tmpFilename) Then
        ' irgendwas ist passiert
        ' something went wrong
        MsgBox "Ups, error"
    Else
        ' um die tatschliche Gre des Bildes zu ermitteln
        ' to get the real size of the picture
        picHidden.Picture = LoadPicture(tmpFilename)
        lblWidth.Caption = picHidden.ScaleWidth & " Pixel original Breite/width"
        lblHeight.Caption = picHidden.ScaleHeight & " Pixel original Hhe/height"
        
        ' und in das angezeigte Image laden, dass dann automatisch die
        ' Gre an das fenster anpat
        ' load picture to imagecontrol, autostrech to window
        imgShow.Height = imgShow.Width * picHidden.ScaleHeight / picHidden.ScaleWidth
        imgShow.Picture = picHidden.Picture
        
    End If

End Sub

Private Sub Form_Load()
    
    ' Filter fr Dateilistbox einsetzen
    ' pattern for file list box
    filFiles.Pattern = "*.sldprt;*.sldasm;*.slddrw"
    
    ' TEMP Pfad ermitteln
    ' Retrieve path to TEMP
    strTemp = String(100, Chr$(0))
    GetTempPath 100, strTemp
    strTemp = Left$(strTemp, InStr(strTemp, Chr$(0)) - 1)

End Sub

Private Sub Form_Resize()
    imgShow.Width = Form1.Width - imgShow.Left - 200
    imgShow.Height = imgShow.Width * picHidden.ScaleHeight / picHidden.ScaleWidth
End Sub
